classdef Heart3D2
    %FUNCLASS Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        Params = [1 1 1 0 0 0]';
    end
    
    methods (Access = public)
        
        function pfixout = pfix(obj)
                       
            
            pfixout =[((obj.Xpos +1)/obj.Xscale) 0 0
                      ((obj.Xpos - 1)/obj.Xscale) 0 0
                      0 ((obj.Ypos + 1)/obj.Yscale) 0
                      0 ((obj.Ypos - 1)/obj.Yscale) 0
                      0 0 ((obj.Zpos - 2/3)/obj.Zscale)
                      0 0 ((obj.Zpos + 2/3)/obj.Zscale)];
        end
        
        function out = Xscale(obj)
            out = obj.Params(1,1);
        %z
        end
        
        function out = Yscale(obj)
            out = obj.Params(2,1);
        %z
        end
        
        function out = Zscale(obj)
            out = obj.Params(3,1);
        %z
        end
         function out = Xpos(obj)
            out = obj.Params(4,1);
        %z
        end
        
        function out = Ypos(obj)
            out = obj.Params(5,1);
        %z
        end
        
        function out = Zpos(obj)
            out = obj.Params(6,1);
        %z
        end
        
        function pboundsout = pbounds(obj)
            
            pboundsout =1.3*[((obj.Xpos - 1)/obj.Xscale) ((obj.Ypos - 1)/obj.Yscale) ((obj.Zpos - 2/3)/obj.Zscale)
                             ((obj.Xpos + 1)/obj.Xscale) ((obj.Ypos + 1)/obj.Yscale) ((obj.Zpos + 2/3)/obj.Zscale)];
            
            
        end
        
        function [Func] = fd(obj,p)
            %Func This returns the distance function
            % This returns signed distance function for a given point
            
            
            
            Func = obj.F(p);
            index = find(Func > 0 & Func < 1);
            
            tmpP = p(index,:);
%             Func = ((p(:,1)./obj.Xscale).^2 + (p(:,2)./obj.Yscale).^2 + (p(:,3)./obj.Zscale).^2).^0.5 - 1;
            Func(index,:) = sign(obj.F(tmpP)).*(sum(obj.distance(tmpP).^2,2)).^0.5;
        end
        
        function [Func] = F(obj,p)
            %Func This returns the distance function
            % This returns signed distance function for a given point
            
            x = p(:,1).*obj.Xscale - obj.Xpos;
            y = p(:,2).*obj.Yscale - obj.Ypos;
            z = p(:,3).*obj.Zscale - obj.Zpos;
            
            Func = ((x.^2+y.^2+(9.*z.^2)./4-1).^3-(9.*y.^3.*z.^2)./80-x.^2.*y.^3).^(1/4);
        end
        
        function [Grad] = dF(obj,p)
            %dF Summary of this method goes here
            %  This returnd the first oFder partial derivitves of the
            %  function for a given point
            x = p(:,1).*obj.Xscale - obj.Xpos;
            y = p(:,2).*obj.Yscale - obj.Ypos;
            z = p(:,3).*obj.Zscale - obj.Zpos;
            
            dFdx = (6*x*(x^2+y^2+(9*z^2)/4-1)^2-2*x*y^3)/(4*((x^2+y^2+(9*z^2)/4-1)^3-(9*y^3*z^2)/80-x^2*y^3)^(3/4));
            dFdy = -(3*x^2*y^2+(27*y^2*z^2)/80-6*y*(x^2+y^2+(9*z^2)/4-1)^2)/(4*((x^2+y^2+(9*z^2)/4-1)^3-(9*y^3*z^2)/80-x^2*y^3)^(3/4));
            dFdz = ((27*z*(x^2+y^2+(9*z^2)/4-1)^2)/2-(9*y^3*z)/40)/(4*((x^2+y^2+(9*z^2)/4-1)^3-(9*y^3*z^2)/80-x^2*y^3)^(3/4));

            Grad = [dFdx dFdy dFdz];
        end
        
        function [SecondGrad] = ddF(obj,p)
            %ddF Second oFder partial derivitives (risidual derivitives)
            %  used for La Grange and CB2 Ellim approx
            x = p(:,1).*obj.Xscale - obj.Xpos;
            y = p(:,2).*obj.Yscale - obj.Ypos;
            z = p(:,3).*obj.Zscale - obj.Zpos;
            
            ddFdxdx = (24*x^2*(x^2+y^2+(9*z^2)/4-1)+6*(x^2+y^2+(9*z^2)/4-1)^2-2*y^3)/(4*((x^2+y^2+(9*z^2)/4-1)^3-(9*y^3*z^2)/80-x^2*y^3)^(3/4))-(3*(6*x*(x^2+y^2+(9*z^2)/4-1)^2-2*x*y^3)^2)/(16*((x^2+y^2+(9*z^2)/4-1)^3-(9*y^3*z^2)/80-x^2*y^3)^(7/4));
            ddFdxdy = (3*(6*x*(x^2+y^2+(9*z^2)/4-1)^2-2*x*y^3)*(3*x^2*y^2+(27*y^2*z^2)/80-6*y*(x^2+y^2+(9*z^2)/4-1)^2))/(16*((x^2+y^2+(9*z^2)/4-1)^3-(9*y^3*z^2)/80-x^2*y^3)^(7/4))-(6*x*y^2-24*x*y*(x^2+y^2+(9*z^2)/4-1))/(4*((x^2+y^2+(9*z^2)/4-1)^3-(9*y^3*z^2)/80-x^2*y^3)^(3/4));
            ddFdxdz = (27*x*z*(x^2+y^2+(9*z^2)/4-1))/(2*((x^2+y^2+(9*z^2)/4-1)^3-(9*y^3*z^2)/80-x^2*y^3)^(3/4))-(3*(6*x*(x^2+y^2+(9*z^2)/4-1)^2-2*x*y^3)*((27*z*(x^2+y^2+(9*z^2)/4-1)^2)/2-(9*y^3*z)/40))/(16*((x^2+y^2+(9*z^2)/4-1)^3-(9*y^3*z^2)/80-x^2*y^3)^(7/4));
            ddFdydy = (24*y^2*(x^2+y^2+(9*z^2)/4-1)+6*(x^2+y^2+(9*z^2)/4-1)^2-6*x^2*y-(27*y*z^2)/40)/(4*((x^2+y^2+(9*z^2)/4-1)^3-(9*y^3*z^2)/80-x^2*y^3)^(3/4))-(3*(3*x^2*y^2+(27*y^2*z^2)/80-6*y*(x^2+y^2+(9*z^2)/4-1)^2)^2)/(16*((x^2+y^2+(9*z^2)/4-1)^3-(9*y^3*z^2)/80-x^2*y^3)^(7/4));
            ddFdydz = (3*((27*z*(x^2+y^2+(9*z^2)/4-1)^2)/2-(9*y^3*z)/40)*(3*x^2*y^2+(27*y^2*z^2)/80-6*y*(x^2+y^2+(9*z^2)/4-1)^2))/(16*((x^2+y^2+(9*z^2)/4-1)^3-(9*y^3*z^2)/80-x^2*y^3)^(7/4))-((27*y^2*z)/40-54*y*z*(x^2+y^2+(9*z^2)/4-1))/(4*((x^2+y^2+(9*z^2)/4-1)^3-(9*y^3*z^2)/80-x^2*y^3)^(3/4));
            ddFdzdz = (3*((27*z*(x^2+y^2+(9*z^2)/4-1)^2)/2-(9*y^3*z)/40)*(3*x^2*y^2+(27*y^2*z^2)/80-6*y*(x^2+y^2+(9*z^2)/4-1)^2))/(16*((x^2+y^2+(9*z^2)/4-1)^3-(9*y^3*z^2)/80-x^2*y^3)^(7/4))-((27*y^2*z)/40-54*y*z*(x^2+y^2+(9*z^2)/4-1))/(4*((x^2+y^2+(9*z^2)/4-1)^3-(9*y^3*z^2)/80-x^2*y^3)^(3/4));
    
            SecondGrad = [ddFdxdx ddFdxdy ddFdxdz;
                          ddFdxdy ddFdydy ddFdydz;
                          ddFdxdz ddFdydz ddFdzdz];
        end
        
        function [vecOut]= distance(obj,ps)
            %Gives vector to closest boundary point
            pboundary = obj.ClosestPoint(ps);
            vecOut = pboundary-ps;
        end
        
       function [pOut]= ClosestPoint(obj,p) %Gives point on closest boundary
            Np = size(p,1);
            pOut = zeros(size(p));
%             options = optimoptions('fmincon','SpecifyObjectiveGradient',true,'Algorithm','sqp')  % indicate gradient is provided
            
            for i = 1:Np
%                 Fmin = @(x) (p(i,1) - x(1)).^2 + (p(i,3) - x(3)).^2 + (p(i,3) - x(3)).^2; %distance function
                Fmin = @(x) obj.DistFunc(p(Np,:),x);
%                 Fmin = @(x) obj.DistFunc(p(i,:),x);
                options = optimoptions('fmincon','SpecifyObjectiveGradient',true,'SpecifyConstraintGradient',true,'OptimalityTolerance',1e-2);
                
                nonlcon = @obj.ConstraintEq;
                pOuttmp = fmincon(@(x) Fmin(x),p(i,:),[],[],[],[],[],[],nonlcon,options);                
                pOut(i,:) = pOuttmp';
            end
            
        end
         
        function [c,ceq,dc,dceq] = ConstraintEq(obj,p)
            c = [];
            ceq = obj.F(p);
            if nargout > 2
               dc = [];
               dceq = obj.dF(p)';
            end
        end
        
        function [f, gradf] = DistFunc(obj,p,x)
             i=1;
             f = (p(i,1) - x(1)).^2 + (p(i,3) - x(3)).^2 + (p(i,3) - x(3)).^2;
             if nargout  > 1
                gradf = [2*(p(i,1)-x(1)) 
                         2*(p(i,2)-x(2))
                         2*(p(i,3)-x(3))];
             end
        end
         
        function xy = plot(obj)
            %plot Gives boudary plot points
            % This returns signed distance function for a given point
            
            x(:,1) = linspace(-obj.Xscale,obj.Xscale,1000);
            y1 = (-(x./obj.Xscale).^2 + 1).^0.5.*obj.Zscale;
            y2 = -(-(x./obj.Xscale).^2 + 1).^0.5*obj.Zscale;
            xy =[x, y1;
                flip(x), flip(y2)];
        end
        
        function [Grad] = tangent(obj,p)
            %dF Summary of this method goes here
            %  This returns the tangent at the point
            
            dFdx(:,1) = (2*p(:,1))./obj.Xscale^2;
            dFdu2(:,1) = (2*p(:,2))./obj.Zscale^2;
            lclGrad = [dFdx dFdu2];
            Grad  = lclGrad./norm(lclGrad);
        end
        
    end
    
    methods (Access = private)
        
        function [F, G] = myoptimfunction(obj,f,g,t)
            %dF Summary of this method goes here
            %  This returnd the first oFder partial derivitves of the function
            F = f(t);
            G = g(t);
        end
        
        
    end
end

