function [outputArg1,outputArg2] = SensitivityPlotter(p,t,fFunc,dXdx,deps,SubPlots,CameraView,LabelsOn,expr)
%SensitivityPlotter Summary of this function goes here
%   Detailed explanation goes here
outputArg1 = 0;
outputArg2 = 0;

if exist('deps','var') == 0
    disp('0.2 offset used for all variables')
    changes = diag(ones(size(fFunc.Params)))*0.2;
elseif all(size(deps) == [1,1])
    disp([num2str(deps) ' offset used for all variables'])
    changes = diag(ones(size(fFunc.Params)))*deps;
elseif size(deps,1) == size(fFunc.Params,1) && size(deps,2) > 1
    disp('User defined vector')
    changes = deps;
elseif size(deps,2) == size(fFunc.Params,1) && size(deps,1) > 1
    disp('User defined vector')
    changes = deps';
elseif (size(deps,1) == size(fFunc.Params,1) && size(deps,2) == 1) || (size(deps,2) == size(fFunc.Params,1) && size(deps,1) == 1)
    disp('User defined vector')
    changes = diag(deps);
else
    disp('Failed to obtain correctly offset value/matrix')
    disp(['The input deps must either be a scalar or a matrix of ' int2str(size(fFunc.Params,1)) '-by-n'])
    disp('0.2 used for offset for all variables')
    changes = diag(ones(size(fFunc.Params)))*0.2;
end

if ~ exist('CameraView','var')
    CameraView = [-30 30];
elseif ~ all(size(CameraView) == [1 2]);
    CameraView = [-30 30];
end

if ~ exist('LabelsOn','var');  LabelsOn = true; end
if ~ exist('SubPlots','var');  SubPlots = false; end
if ~exist('expr','var'); expr = []; end
%% Plot Sensitiviy Offsets

xyorig = fFunc.plot;
count = 0;
if exist('SubPlots','var') && SubPlots == true
    OffsetFig = figure;
    n = 3;
    m = ceil((size(fFunc.Params,1)+1)/n);
end

for change = changes'
    count = count+1;
    if size(p,2) == 2
        P_Updates = [dXdx(1:2:end,:)*change, dXdx(2:2:end,:)*change];
    else
        P_Updates = [dXdx(1:3:end,:)*change, dXdx(2:3:end,:)*change, dXdx(3:3:end,:)*change];
    end
    if exist('SubPlots','var') && SubPlots == true
        subplot(m,n,count); hold on;
    else
        OffsetFig = figure;
    end
    MESHplotter(p,t,OffsetFig);
    ln = MESHplotter(p + P_Updates,t,OffsetFig,true);
    ln.EdgeColor = 'r';
    ln.LineStyle = ':';
    ln.FaceColor = 'r';
    ln.FaceAlpha = 0.3;
    tmpfunc = fFunc;tmpfunc.Params = tmpfunc.Params + change;
    xy = tmpfunc.plot;
    
    figure(OffsetFig)
    if exist('SubPlots','var') && SubPlots == true
        subplot(m,n,count); hold on;
    end
    hold on;
    plot(xy(:,1),xy(:,2),'k-.','LineWidth',2)
    axis equal
    axis tight
    if ~(exist('SubPlots','var') && SubPlots == true)
        leg = legend('Original','Predicted','Updated Function Boundary');
    end
    
    if size(p,2) ==3
        view(gca,CameraView);
        cameratoolbar('SetCoordSys', 'none')
        cameratoolbar
        axis tight
    end
    if LabelsOn == true
        xlabel('x')
        ylabel('y')
        if size(p,2) ==3,zlabel('z'); end
    end
end
if exist('SubPlots','var') && SubPlots == true
    leg = legend('Original','Predicted','Updated Function Boundary');
    count = count+1; xss = subplot(m,n,count);
    leg.Position =[xss.Position([1 2])+[0 xss.Position([4])]-[0 leg.Position(4)]  leg.Position(3:4)]; delete(xss);
end
%% Plot sensitivty maps
if exist('SubPlots','var') && SubPlots == true
    sensfig = figure;
end
count =0;
for ParNum = 1:size(fFunc.Params,1)
    count = count+1;
    
    if size(p,2) == 2
        mags = sum([dXdx(1:2:end,ParNum), dXdx(2:2:end,ParNum)].^2,2).^0.5;
    else
        mags = sum([dXdx(1:3:end,ParNum), dXdx(2:3:end,ParNum), dXdx(3:3:end,ParNum)].^2,2).^0.5;
    end
    
    if exist('SubPlots','var') && SubPlots == true
        subplot(m,n,count); hold on;
    else
        sensfig = figure;
    end
    SensPlot(p,t,mags,expr);
    if size(p,2) ==3
        view(gca,CameraView);
        cameratoolbar('SetCoordSys', 'none')
        cameratoolbar
        
%         axis tight
    end
    a = gca;
    a.FontSize = 16;
    if LabelsOn == true
%         xlabel('x')
%         ylabel('y')
        if size(p,2) ==3,zlabel('z'); end
    end
end

% sensfig = [sensfig.Position(1:2) sensfig.Position(4)]

end

