classdef Squable3D
    %FUNCLASS Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        Params = [0 0 0 50 50 50 1 1 1 1 1 1]';
        x1;
        x2;
        x3;
        x4;
        x5;
        x6;
        x7;
        x8;
        x9;
        x10;
        x11;
        x12;
        neg = 1;
        actdist = 0;
    end
    
    methods
        
        function out = get.x1(obj)
            out = obj.Params(1,1);
            %z
        end
        
        function out = get.x2(obj)
            out = obj.Params(2,1);
            %z
        end
        
        function out = get.x3(obj)
            out = obj.Params(3,1);
            %z
        end
        function out = get.x4(obj)
            out = obj.Params(4,1);
            %z
        end
        
        function out = get.x5(obj)
            out = obj.Params(5,1);
            %z
        end
        
        function out = get.x6(obj)
            out = obj.Params(6,1);
            %z
        end
        
        function out = get.x7(obj)
            out = obj.Params(7,1);
            %z
        end
        
        function out = get.x8(obj)
            out = obj.Params(8,1);
            %z
        end
        
        function out = get.x9(obj)
            out = obj.Params(9,1);
            %z
        end
        
        function out = get.x10(obj)
            out = obj.Params(10,1);
            %z
        end
        
        function out = get.x11(obj)
            out = obj.Params(11,1);
            %z
        end
        
        function out = get.x12(obj)
            out = obj.Params(12,1);
            %z
        end
        
    end
    methods (Access = public)
        function pfixout = pfix(obj,p)
            
            pfixout = [];
%             pfixout =[((obj.x1 +1)/obj.Xscale) 0 0
%                 ((obj.x1 - 1)/obj.Xscale) 0 0
%                 0 ((obj.x2 + 1)/obj.Yscale) 0
%                 0 ((obj.x2 - 1)/obj.Yscale) 0
%                 0 0 ((obj.x3 - 2/3)/obj.Zscale)
%                 0 0 ((obj.x3 + 2/3)/obj.Zscale)];
        end
        
        function pboundsout = pbounds(obj)
            
            pboundsout =10*[-1 -1 -1
                           1 1 1];
            
            
        end
        
        function [Func] = fd(obj,p)
            %Func This returns the distance function
            % This returns signed distance function for a given point
            
            
            
            Func = obj.F(p);
            Func = sign(Func).*(abs(Func)).^0.25;
            if obj.actdist == 1
            index = find(Func > -2 & Func < 2);
            else
                index=[];
            end
            tmpP = p(index,:);
%                         Func = ((p(:,1)./obj.Xscale).^2 + (p(:,2)./obj.Yscale).^2 + (p(:,3)./obj.Zscale).^2).^0.5 - 1;
            Func(index,:) = sign(obj.F(tmpP)).*(sum(obj.distance(tmpP).^2,2)).^0.5;
            
        end
        
        function [Func] = F(obj,p)
            %Func This returns the distance function
            % This returns signed distance function for a given point
            
            x = (p(:,1) - obj.x1)/obj.x10;
            y = (p(:,2) - obj.x2)/obj.x11;
            z = (p(:,3) - obj.x3)/obj.x12;
            
            Func{1} =  -obj.x4*x.^2 -obj.x5*y.^2 -obj.x6*z.^2 + (obj.x7*x.^4 + obj.x8*y.^4 + obj.x9*z.^4) + 1000;
        end
        
        function [Grad] = dF(obj,p)
            % dF Summary of this method goes here
            % This returnd the first oFder partial derivitves of the
            % function for a given point
            x = (p(:,1) - obj.x1)/obj.x10; dx = 1/obj.x10;
            y = (p(:,2) - obj.x2)/obj.x11; dy = 1/obj.x11;
            z = (p(:,3) - obj.x3)/obj.x12; dz = 1/obj.x12;
            
            dFdx = (-2*obj.x4*x + 4*obj.x7*x.^3)*dx;
            dFdy = (-2*obj.x5*y + 4*obj.x8*y.^3)*dy;
            dFdz = (-2*obj.x6*z + 4*obj.x9*z.^3)*dz;
            Grad{1} = [dFdx dFdy dFdz];

        end
%         
        function [SecondGrad] = ddF(obj,p)
            %ddF Second oFder partial derivitives (risidual derivitives)
            %  used for La Grange and CB2 Ellim approx
            x = (p(:,1) - obj.x1)/obj.x10; dx = 1/obj.x10;
            y = (p(:,2) - obj.x2)/obj.x11; dy = 1/obj.x11;
            z = (p(:,3) - obj.x3)/obj.x12; dz = 1/obj.x12;
             
            ddFdxdx = (-2*obj.x4 + 12*obj.x7*x.^2)*dx^2;
            ddFdxdy = 0;
            ddFdxdz = 0;
            ddFdydy = (-2*obj.x5 + 12*obj.x8*y.^2)*dy^2;
            ddFdydz = 0;
            ddFdzdz = (-2*obj.x6 + 12*obj.x9*z.^2)*dz^2;
            
            SecondGrad{1} = [ddFdxdx ddFdxdy ddFdxdz;
                          ddFdxdy ddFdydy ddFdydz;
                          ddFdxdz ddFdydz ddFdzdz];
        end
        
        function [vecOut]= distance(obj,ps)
            %Gives vector to closest boundary point
            pboundary = obj.ClosestPoint(ps);
            vecOut = pboundary-ps;
        end
        
        function [pOut]= ClosestPoint(obj,p) %Gives point on closest boundary
            Np = size(p,1);
            pOut = zeros(size(p));
            %             options = optimoptions('fmincon','SpecifyObjectiveGradient',true,'Algorithm','sqp')  % indicate gradient is provided
            
            for i = 1:Np
                %                 Fmin = @(x) (p(i,1) - x(1)).^2 + (p(i,3) - x(3)).^2 + (p(i,3) - x(3)).^2; %distance function
                Fmin = @(x) obj.DistFunc(p(Np,:),x);
                %                 Fmin = @(x) obj.DistFunc(p(i,:),x);
                options = optimoptions('fmincon','SpecifyObjectiveGradient',true,'SpecifyConstraintGradient',true,'OptimalityTolerance',1e-2);
                
                nonlcon = @obj.ConstraintEq;
                pOuttmp = fmincon(@(x) Fmin(x),p(i,:),[],[],[],[],[],[],nonlcon,options);
                pOut(i,:) = pOuttmp';
            end
            
        end
        
        function [c,ceq,dc,dceq] = ConstraintEq(obj,p)
            c = [];
            ceq = obj.F(p);
            if nargout > 2
                dc = [];
                dceq = obj.dF(p)';
            end
        end
        
        function [f, gradf] = DistFunc(obj,p,x)
            i=1;
            f = (p(i,1) - x(1)).^2 + (p(i,3) - x(3)).^2 + (p(i,3) - x(3)).^2;
            if nargout  > 1
                gradf = [2*(p(i,1)-x(1))
                    2*(p(i,2)-x(2))
                    2*(p(i,3)-x(3))];
            end
        end
        
        function xy = plot(obj)
            %plot Gives boudary plot points
            % This returns signed distance function for a given point
            
%             x(:,1) = linspace(-obj.Xscale,obj.Xscale,1000);
%             y1 = (-(x./obj.Xscale).^2 + 1).^0.5.*obj.Zscale;
%             y2 = -(-(x./obj.Xscale).^2 + 1).^0.5*obj.Zscale;
%             xy =[x, y1;
%                 flip(x), flip(y2)];
            xy = zeros(0,3);
        end
        
        function [Grad] = tangent(obj,p)
            %dF Summary of this method goes here
            %  This returns the tangent at the point
            
            dFdx(:,1) = (2*p(:,1))./obj.Xscale^2;
            dFdu2(:,1) = (2*p(:,2))./obj.Zscale^2;
            lclGrad = [dFdx dFdu2];
            Grad  = lclGrad./norm(lclGrad);
        end
        
    end
    
    methods (Access = private)
        
        function [F, G] = myoptimfunction(obj,f,g,t)
            %dF Summary of this method goes here
            %  This returnd the first oFder partial derivitves of the function
            F = f(t);
            G = g(t);
        end
        
        
    end
end

