function[F,dFdx,broken] = Truss3D(x,Ldes)

x1 = x(1);
x2 = x(2);
x3 = x(3);
x4 = x(4);
x5 = x(5);
x6 = x(6);

broken = false;

Lc = ((x6 - x3)^2 + (x5 - x2)^2+(x4 - x1)^2 )^0.5;

if round(Lc*10000) == 0
    broken = true;
end

       
    Fbar = (Ldes - Lc)/Ldes;
    
    l = (x4 - x1)/Lc;
    m = (x5 - x2)/Lc;
    n = (x6 - x3)/Lc;
    
    F1x1 = (Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2))/(Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2))-((2*x1-2*x4)*(x1-x4))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2))-((2*x1-2*x4)*(x1-x4)*(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2)))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(3/2));
    F1x2 = -((2*x2-2*x5)*(x1-x4))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2))-((2*x2-2*x5)*(x1-x4)*(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2)))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(3/2));
    F1x3 = -((2*x3-2*x6)*(x1-x4))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2))-((2*x3-2*x6)*(x1-x4)*(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2)))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(3/2));
    F1x4 = ((2*x1-2*x4)*(x1-x4))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2))-(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2))/(Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2))+((2*x1-2*x4)*(x1-x4)*(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2)))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(3/2));
    F1x5 = ((2*x2-2*x5)*(x1-x4))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2))+((2*x2-2*x5)*(x1-x4)*(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2)))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(3/2));
    F1x6 = ((2*x3-2*x6)*(x1-x4))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2))+((2*x3-2*x6)*(x1-x4)*(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2)))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(3/2));
    F2x2 = (Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2))/(Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2))-((2*x2-2*x5)*(x2-x5))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2))-((2*x2-2*x5)*(x2-x5)*(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2)))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(3/2));
    F2x3 = -((2*x3-2*x6)*(x2-x5))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2))-((2*x3-2*x6)*(x2-x5)*(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2)))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(3/2));
    F2x4 = ((2*x1-2*x4)*(x2-x5))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2))+((2*x1-2*x4)*(x2-x5)*(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2)))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(3/2));
    F2x5 = ((2*x2-2*x5)*(x2-x5))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2))-(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2))/(Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2))+((2*x2-2*x5)*(x2-x5)*(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2)))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(3/2));
    F2x6 = ((2*x3-2*x6)*(x2-x5))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2))+((2*x3-2*x6)*(x2-x5)*(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2)))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(3/2));
    F3x3 = (Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2))/(Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2))-((2*x3-2*x6)*(x3-x6))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2))-((2*x3-2*x6)*(x3-x6)*(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2)))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(3/2));
    F3x4 = ((2*x1-2*x4)*(x3-x6))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2))+((2*x1-2*x4)*(x3-x6)*(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2)))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(3/2));
    F3x5 = ((2*x2-2*x5)*(x3-x6))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2))+((2*x2-2*x5)*(x3-x6)*(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2)))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(3/2));
    F3x6 = ((2*x3-2*x6)*(x3-x6))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2))-(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2))/(Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2))+((2*x3-2*x6)*(x3-x6)*(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2)))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(3/2));
    F4x4 = (Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2))/(Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2))-((2*x1-2*x4)*(x1-x4))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2))-((2*x1-2*x4)*(x1-x4)*(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2)))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(3/2));
    F4x5 = -((2*x2-2*x5)*(x1-x4))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2))-((2*x2-2*x5)*(x1-x4)*(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2)))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(3/2));
    F4x6 = -((2*x3-2*x6)*(x1-x4))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2))-((2*x3-2*x6)*(x1-x4)*(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2)))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(3/2));
    F5x5 = (Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2))/(Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2))-((2*x2-2*x5)*(x2-x5))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2))-((2*x2-2*x5)*(x2-x5)*(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2)))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(3/2));
    F5x6 = -((2*x3-2*x6)*(x2-x5))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2))-((2*x3-2*x6)*(x2-x5)*(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2)))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(3/2));
    F6x6 = (Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2))/(Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2))-((2*x3-2*x6)*(x3-x6))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2))-((2*x3-2*x6)*(x3-x6)*(Ldes-((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(1/2)))/(2*Ldes*((x1-x4)^2+(x2-x5)^2+(x3-x6)^2)^(3/2));

%Force vector constribxtion

F(1,1) = -Fbar*l;
F(2,1) = -Fbar*m;
F(3,1) = -Fbar*n;
F(4,1) =  Fbar*l;
F(5,1) =  Fbar*m;
F(6,1) =  Fbar*n;


dFdx = [F1x1 F1x2 F1x3 F1x4 F1x5 F1x6;
        F1x2 F2x2 F2x3 F2x4 F2x5 F2x6;
        F1x3 F2x3 F3x3 F3x4 F3x5 F3x6;
        F1x4 F2x4 F3x4 F4x4 F4x5 F4x6;
        F1x5 F2x5 F3x5 F4x5 F5x5 F5x6;
        F1x6 F2x6 F3x6 F4x6 F5x6 F6x6];