%MESHDEMO2d Distmesh2d examples.
clear all;  close all; format short; format compact
% clc;
rand('state',1); % Always the same results this is important for evaluating the methods against each other.
set(gcf,'renderer','opengl');

% echo on

%% Cb2 FIXED Points on surface

pfix = zeros(0,2);
pmpc = zeros(0,2);

tic
tol = 10^-8;

%% Function assignment

fdFunc = f_BowTie; depsParams = [3 3 50 20 -1 -4 ]'; ParamUpdate = [2 -4 10 -8 -1 -2]';h_max = 0.3; h_min = 0.06; disp('Mesh on BowTie');FileName = 'MeshData_Bowtie.mat'; 

h = @(p) huniform(p,h_max);% easiest to solve

%% Mesh run
if exist('distmesh2d','file') && ~exist(FileName,'file') 
    [p,t]=distmesh2d(@(p) fdFunc.F(p),h,h_max,fdFunc.pbounds,fdFunc.pfix);
    figure(1);close
    save(FileName,'p','t')
else
    load(FileName)
end

SubPlotOn = true;

[p1,dXdx] = MeshSensGen2d(fdFunc,p,t,[],[],tol,10^-6);

 hold on
xx1 = find(p1(:,2)>0.5 & p1(:,2)<0.8);
PPs = sortrows(p1(xx1,:),1);
plot(PPs(:,1),PPs(:,2),'r-.','LineWidth',3);

xx2 = find(p1(:,2)>-0.6 & p1(:,2)<-0.3);
PPs = sortrows(p1(xx2,:),1);
plot(PPs(:,1),PPs(:,2),'r-.','LineWidth',3);

yy1 = find(p1(:,1)>-2.6 & p1(:,1)<-2.4);
PPs = sortrows(p1(yy1,:),2);
plot(PPs(:,1),PPs(:,2),'r-.','LineWidth',3);

yy2 = find(p1(:,1)>-0.7 & p1(:,1)<-0.55);
PPs = sortrows(p1(yy2,:),2);
plot(PPs(:,1),PPs(:,2),'r-.','LineWidth',3);

yy3 = find(p1(:,1)>1.3 & p1(:,1)<1.5);
PPs = sortrows(p1(yy3,:),2);
plot(PPs(:,1),PPs(:,2),'r-.','LineWidth',3);

yy4 = find(p1(:,1)>2.45 & p1(:,1)<2.6);
PPs = sortrows(p1(yy4,:),2);
plot(PPs(:,1),PPs(:,2),'r-.','LineWidth',3);

SensitivityPlotter(p1,t,fdFunc,dXdx,depsParams,SubPlotOn);
disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
disp('% Paused. Press any Key to continue %')
disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'),pause
close all;

% Length function update
h = @(p) hradialgenerator2linearsmall3(p,h_max,h_min); %Non-uniform mesh update
[p2,dXdx2] = MeshSensGen2d(fdFunc,p1,t,[],h,tol);
SensitivityPlotter(p2,t,fdFunc,dXdx,depsParams,SubPlotOn);

figure(1)
hold on

PPs = sortrows(p2(xx1,:),1);
plot(PPs(:,1),PPs(:,2),'r-.','LineWidth',3);

PPs = sortrows(p2(xx2,:),1);
plot(PPs(:,1),PPs(:,2),'r-.','LineWidth',3);

PPs = sortrows(p2(yy1,:),2);
plot(PPs(:,1),PPs(:,2),'r-.','LineWidth',3);

PPs = sortrows(p2(yy2,:),2);
plot(PPs(:,1),PPs(:,2),'r-.','LineWidth',3);

PPs = sortrows(p2(yy3,:),2);
plot(PPs(:,1),PPs(:,2),'r-.','LineWidth',3);

PPs = sortrows(p2(yy4,:),2);
plot(PPs(:,1),PPs(:,2),'r-.','LineWidth',3);
%SensitivityPlotter(p2,t,fdFunc,dXdx,depsParams,SubPlotOn);


% a = gcf;
% b = gca;
% b.Position = [0.05 0.05 0.75 0.9];
% b.FontSize = 16
% colorbar('FontSize',20)
% colormap('gray')


disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
disp('% Paused. Press any Key to continue %')
disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'),pause
close all;


%% Length function update

h = @(p) hradialgenerator2linearsmall2(p,h_max,h_min); %Non-uniform mesh update
h = @(p) huniform(p,h_max,h_min);% easiest to solve
[p3,dXdx] = MeshSensGen2d(fdFunc,p1,t,[],h,tol);

% update using specified values for each variable
% SensitivityPlotter(p3,t,fdFunc,dXdx,depsParams,SubPlotOn);
disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
disp('% Paused. Press any Key to continue %')
disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'),pause
close all;

%% Control variable update

% dXdx = dXdx./(ones(size(dXdx,1),1)*max(abs(dXdx)));


updatedfd_Func = fdFunc;
updatedfd_Func.Params = fdFunc.Params + ParamUpdate;
X_updates = real(dXdx2*ParamUpdate);
P_updates = [X_updates(1:2:end,1), X_updates(2:2:end,1)];
h = @(p) huniform(p,h_max,h_min);% easiest to solve

[p4,dXdx] = MeshSensGen2d(updatedfd_Func,p2+P_updates,t,[],[],tol);

% update using specified values for each variable

%SensitivityPlotter(p4,t,updatedfd_Func,dXdx,depsParams,SubPlotOn);

disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
disp('% Paused. Press any Key to continue %')
disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'),pause

% qual = simpqual(p,t,1);
% qual = min(qual);

% Overlay in updated from 3 to 4 predicted position
figNo = figure;
ln = MESHplotter(p2,t,figNo);
ln.EdgeColor = [0.5 0.5 0.5];
ln = MESHplotter(p2+P_updates,t,figNo,true);
ln.EdgeColor = 'k';
ln.LineStyle = ':';
ln.LineWidth = 1;
ln = MESHplotter(p4,t,gcf,true);
ln.EdgeColor = [0.1 0.1 0.1];
ln.LineStyle = '-';
ln.LineWidth = 1.2;
hold on
xy = updatedfd_Func.plot;
plot(xy(:,1),xy(:,2),'r-.','LineWidth',1.5)
title('Predicted overlay')
legend('Original','Predicted Mesh','Updated Func. Resolved','Updated Func. Boundary','Location','northeast')
axis auto