%MESHDEMO2d Distmesh2d examples.
clear all;  close all; format short; format compact
rand('state',1); % Always the same results this is important for evaluating the methods against each other.
set(gcf,'renderer','opengl');


% echo on

%% Cb2 FIXED Points on surface

pfix = zeros(0,2);
pmpc = zeros(0,2);

tic
tol = 10^-8;

%% Function assignment

fdFunc = f_Ellipse; ParamUpdate = [0.3 -0.5 0 1]';h_max = 0.1;h_min = .02; disp('Mesh on ellipse');FileName = 'Meshdata_EllipseMesh.mat'; 
% fdFunc = f_Squircle; ParamUpdate = [0.1 -1.2 -1 -2]';h_max = 0.1;h_min = .04; disp('Mesh on squircle');FileName = 'MeshData_Squircle.mat';
% fdFunc = f_Cardioid; ParamUpdate = [0.4 -0.5 12 -5  0.1]';h_max = 0.2;h_min = .1; disp('Mesh on cardioid');FileName = 'MeshData_Cardiod.mat';
% fdFunc = f_Cardioid; ParamUpdate = [0 1 0 0  1]';h_max = 0.2;h_min = .1; disp('Mesh on cardioid');FileName = 'MeshData_Cardiod.mat'; %Shows interaction between Width and shape paramenter a
% fdFunc = f_Cardioid; ParamUpdate = [1 0 0 0  -0.5]';h_max = 0.2;h_min = .1; disp('Mesh on cardioid');FileName = 'MeshData_Cardiod.mat'; %Shows interaction between Height and shape paramenter a
% fdFunc = f_Cardioid; ParamUpdate = [20 15 20 20  0.1]';h_max = 0.2;h_min = .1; disp('Mesh on cardioid');FileName = 'MeshData_Cardiod.mat';
% fdFunc = f_Cardioid; ParamUpdate = [4 4 2 20  0.5]';h_max = 0.2;h_min = .1; disp('Mesh on cardioid');FileName = 'MeshData_Cardiod.mat'; %Shows interaction with a highly non-linear relation

h = @(p) huniform(p,h_max);% easiest to solve

%% Mesh run
if exist('distmesh2d','file') && ~exist(FileName,'file')
    [p,t]=distmesh2d(@(p) fdFunc.F(p),h,h_max*1.5,fdFunc.pbounds,fdFunc.pfix);
    figure(1);close
    save(FileName,'p','t')
else
    load(FileName)
end

SubPlotOn = true;

[p1,dXdx] = MeshSensGen2d(fdFunc,p,t,[],h,tol);
SensitivityPlotter(p1,t,fdFunc,dXdx,[],SubPlotOn); 

disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
disp('% Paused. Press any Key to continue %')
disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'),pause
close all;

% Length function update
h = @(p) hradialgenerator2linearsmall(p,h_max,h_min); %Non-uniform mesh update
[p2,dXdx] = MeshSensGen2d(fdFunc,p1,t,[],h,tol);
% SensitivityPlotter(p2,t,fdFunc,dXdx,0.4,SubPlotOn);
disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
disp('% Paused. Press any Key to continue %')
disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'),pause
close all;

% Demonstrate 
[p22,dXdx2] = MeshSensGen2d(fdFunc,p2,t,[],[],tol);
% SensitivityPlotter(p22,t,fdFunc,dXdx,0.4,SubPlotOn)

disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
disp('% Paused. Press any Key to continue %')
disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'),pause
close all;


%% Length function update

h = @(p) hradialgenerator2linearsmall2(p,h_max,h_min); %Non-uniform mesh update
h = @(p) huniform(p,h_max,h_min);% easiest to solve
[p3,dXdx] = MeshSensGen2d(fdFunc,p2,t,[],h,tol);

% update using specified values for each variable
% SensitivityPlotter(p3,t,fdFunc,dXdx,0.4,SubPlotOn);
disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
disp('% Paused. Press any Key to continue %')
disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'),pause
close all;

%% Control variable update

% dXdx = dXdx./(ones(size(dXdx,1),1)*max(abs(dXdx)));


updatedfd_Func = fdFunc;
updatedfd_Func.Params = fdFunc.Params + ParamUpdate;
X_updates = real(dXdx*ParamUpdate);
P_updates = [X_updates(1:2:end,1), X_updates(2:2:end,1)];
h = @(p) huniform(p,h_max,h_min);% easiest to solve

[p4,dXdx] = MeshSensGen2d(updatedfd_Func,p3+P_updates,t,[],[],tol);

% update using specified values for each variable

% SensitivityPlotter(p4,t,updatedfd_Func,dXdx,2,SubPlotOn);

disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
disp('% Paused. Press any Key to continue %')
disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'),pause

% Overlay in updated from 3 to 4 predicted position
figNo = figure;
ln = MESHplotter(p3,t,figNo);
ln.EdgeColor = [0.5 0.5 0.5];
ln = MESHplotter(p3+P_updates,t,figNo,true);
ln.EdgeColor = 'k';
ln.LineStyle = ':';
ln.LineWidth = 1;
ln = MESHplotter(p4,t,gcf,true);
ln.EdgeColor = [0.1 0.1 0.1];
ln.LineStyle = '-';
ln.LineWidth = 0.6;
hold on
xy = updatedfd_Func.plot;
plot(xy(:,1),xy(:,2),'k-','LineWidth',1.5)
% title('Predicted overlay')
legend('Original','Predicted Mesh','Updated Func. Resolved','Updated Func. Boundary','Location','northeast')
axis auto



