%MESHDEMO2d Distmesh2d examples.
clear all;  close all; format short; format compact
% clc;
rand('state',1); % Always the same results this is important for evaluating the methods against each other.
set(gcf,'renderer','opengl');


% echo on

%% Cb2 FIXED Points on surface

pfix = zeros(0,2);
pmpc = zeros(0,2);

tic
tol = 10^-8;

%% Function assignment

% fdFunc = EllipseFunction6_3d; ParamUpdate = [0.3 0.3 -0.3]';h_max = 0.2;h_min = .02; disp('Mesh on ellipse');FileName = 'data_EllipseMesh3d.mat'; 
fdFunc = Squable3D;

ParamUpdate = [20 5 5 ...
               3 0 -4 ...
               -0.1 0.1 0 ...
               0.1 1 0]'; 
           
DemUpdate = [-3   -3    -3 ...
              20   20   20 ...
             -0.5 -0.5 -0.5 ...
              0.2 -0.2  0.5]'; 

disp('Mesh on 3D heart'); FileName = 'data_squable3D.mat';




h = @(p) huniform(p,h_max);% easiest to solve
h = @(p) ones(size(p,1),1);



% h = @(p) h_DistHeart(p,h_max,h_min,fdFunc.pfix);
%% Mesh run
load(FileName)
% if exist('distmeshnd','file') && ~exist(FileName,'file')
%     [p,t]=distmeshnd(@(p) fdFunc.fd(p),h,h_max,fdFunc.pbounds,fdFunc.pfix);
%     figure(1);close
%     p = unique([fdFunc.pfix;p],'rows');
%     t = delaunayn(p)
%     save(FileName,'p','t')
% else
%     load(FileName)
% end
 
SubPlotOn = false;

[p1,dXdx, pnums] = MeshSensGen3d(fdFunc,p,t,[],[],tol);
SensitivityPlotter(p1,t,fdFunc,dXdx,DemUpdate,SubPlotOn,[-45 30]); 

disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
disp('% Paused. Press any Key to continue %')
disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'),pause
close all;

updatedfd_Func = fdFunc;
updatedfd_Func.Params = fdFunc.Params + ParamUpdate;
X_updates = real(dXdx*ParamUpdate);
P_updates = [X_updates(1:3:end,1), X_updates(2:3:end,1), X_updates(3:3:end,1)];
h = @(p) huniform(p,h_max,h_min);% easiest to solve

[p2,dXdx, pnums] = MeshSensGen3d(updatedfd_Func,p1+P_updates,t,pnums,[],tol);

% update using specified values for each variable

SensitivityPlotter(p2,t,updatedfd_Func,dXdx,DemUpdate,SubPlotOn);

disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%')
disp('% Paused. Press any Key to continue %')
disp('%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'),pause

% Overlay in updated from 3 to 4 predicted position
figNo = figure;
ln = MESHplotter(p1,t,figNo);
ln.EdgeColor = [0.5 0.5 0.5];
ln = MESHplotter(p1+P_updates,t,figNo,true);
ln.EdgeColor = 'r';
ln.LineStyle = ':';
ln.LineWidth = 1;
ln = MESHplotter(p2,t,gcf,true);
ln.EdgeColor = 'k';
ln.LineStyle = '-';
ln.LineWidth = 0.6;
ln.FaceColor = [1 1 1];
hold on
title('Predicted overlay')
legend('Original','Predicted Mesh','Updated Func. Resolved','Updated Func. Boundary','Location','northeast')
view(gca,[-30 22]);

