classdef f_BowTie
    %FUNCLASS Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        Params = [0 0 64 4 4 10]';
        x1;
        x2;
        x3;
        x4;
        x5;
        x6;        
    end
    
    methods %Get set properties
        
        function x = get.x1(obj)
            x = obj.Params(1);
        end 
        
        function x = get.x2(obj)
            x = obj.Params(2);
        end 
        
        function x = get.x3(obj)
            x = obj.Params(3);
        end
        
        function x = get.x4(obj)
            x = obj.Params(4);
        end       
        
        function rad = get.x5(obj)
           rad = obj.Params(5);
        end
        
        function rad = get.x6(obj)
           rad = obj.Params(6);
        end   
        
     
            
    end
    
    methods (Access = public)
        
        function pfixout = pfix(obj)
            pfixout = [];
%             pfixout =[obj.Xpos  obj.Ypos+obj.Height*sqrt(obj.rad)
%                       obj.Xpos  obj.Ypos-obj.Height*sqrt(obj.rad)
%                       obj.Xpos+obj.Width*sqrt(obj.rad)  obj.Ypos
%                       obj.Xpos-obj.Width*sqrt(obj.rad)  obj.Ypos];
        end
        
        function pboundsout = pbounds(obj)
%             pboundsout =[-2*obj.Width*sqrt(obj.rad)+obj.Xpos -2*obj.Height*sqrt(obj.rad)+obj.Ypos 
%                           2*obj.Width*sqrt(obj.rad)+obj.Xpos 2*obj.Height*sqrt(obj.rad)+obj.Ypos];
              pboundsout = [-10+obj.x1 -10+obj.x2; 10+obj.x1 10+obj.x2];
        end
        
        function [Func] = F(obj,p)
            %Func This returns the distance function
            % This returns signed distance function for a given point
            x = (p(:,1)-obj.x1);
            y = (p(:,2)-obj.x2);
            X3 = obj.x3;
            X4 = obj.x4;
            X5 = obj.x5;
            X6 = obj.x6;
            
            Func = - (X3.*x.^2 + X4.*y.^2) + (X5.*x.^4  + X6.*y.^4)  - 7;
        end
                
        function [Grad] = dF(obj,p)
            %dF First Order derivitive
            %  This returnd the first order partial derivitves of the
            %  function for a given point
            x = (p(:,1)-obj.x1);
            y = (p(:,2)-obj.x2);
            X3 = obj.x3;
            X4 = obj.x4;
            X5 = obj.x5;
            X6 = obj.x6;
            
           dFdx =4*X5*x^3 - 2*X3*x;
           dFdy =4*X6*y^3 - 2*X4*y;

            
            Grad = [dFdx dFdy];
        end
        
        function [SecondGrad] = ddF(obj,p)
            %ddF Second order partial derivitives (risidual derivitives)
            %  used for La Grange and CB2 Ellim approx
            
            x = (p(:,1)-obj.x1);
            y = (p(:,2)-obj.x2);
            X3 = obj.x3;
            X4 = obj.x4;
            X5 = obj.x5;
            X6 = obj.x6;

            ddFdxdx =12*X5*x^2 - 2*X3;
            ddFdxdy =0;
            ddFdydx =0;
            ddFdydy =12*X6*y^2 - 2*X4;
            
            SecondGrad = [ddFdxdx ddFdxdy;
                          ddFdydx ddFdydy];
        end
        
        function xy = plot(obj)
            %plot Gives boudary plot points
            % This returns signed distance function for a given point
            bounds = obj.pbounds;
            CurFig = gcf;
            [x,y] = meshgrid(bounds(1,1):.01:bounds(2,1),bounds(1,2):.01:bounds(2,2));
            zz = obj.F([reshape(x,[],1),reshape(y,[],1)]);
            z = reshape(zz,size(x,1),size(x,2));
            tmpfig = figure(100);
            [C,h] = contour(x,y,z,[0 0]);
            Lvls = h.LevelList;
            k1 = 1;
            idxc = find(C(1,:) == Lvls(k1));
            Llen = C(2,idxc);
            
            if (Llen(1) - idxc(1))<10
                idxc = idxc(2:end);
                Llen = C(2,idxc);
            end
            
            xy = C(:,idxc(1)+1 : idxc(1)+1+Llen(1)-1)';
            close(tmpfig)
            try
            figure(CurFig)
            catch 
            end
        end
        
    end
    

end

