classdef f_Cardioid
    %FUNCLASS Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        Params = [2 2 2 2 2]';
%         Params = [1 4 -0.5 -0.5]';
        Height;
        Width;
        Xpos;
        Ypos;
        a;
    end
    
    methods %Get set properties
        
        function x = get.Width(obj)
            x = obj.Params(1);
        end 
        
        function x = get.Height(obj)
            x = obj.Params(2);
        end 
        
        function x = get.Xpos(obj)
            x = obj.Params(3);
        end
        
        function x = get.Ypos(obj)
            x = obj.Params(4);
        end       
        
        function x = get.a(obj)
            x = obj.Params(5);
        end 

    end
    
    methods (Access = public)
        
        function pfixout = pfix(obj)
            pfixout =[
%                 0 obj.Height
                  obj.Xpos  obj.Ypos
%                 0 -obj.Height
%                 -obj.Width+obj.Xpos obj.Ypos
%                 obj.Params(3,1)  obj.Params(4,1)
                ];

        end
        
        function pboundsout = pbounds(obj)
            pboundsout = obj.a*[-5*obj.Width+obj.Xpos -5*obj.Height+obj.Ypos 
                                 5*obj.Width+obj.Xpos 5*obj.Height+obj.Ypos];
        end
        
        function [Func] = F(obj,p)
            %Func This returns the distance function
            % This returns signed distance function for a given point
            x = (p(:,1)-obj.Xpos)./obj.Width;
            y = (p(:,2)-obj.Ypos)./obj.Height;
            a = obj.a;
            Func = (x.^2+y.^2).^2 + 4.*a.*x.*(x.^2+y.^2)-4*a.^2.*y.^2;
%             Func =((obj.Xpos - p(:,1)).^2./obj.Width.^2 + (obj.Ypos - p(:,2)).^2./obj.Height.^2).^2 - (4.*obj.a.^2.*(obj.Ypos - p(:,2)).^2)./obj.Height.^2 - (4*obj.a.*((obj.Xpos - p(:,1)).^2./obj.Width^2 + (obj.Ypos - p(:,2)).^2./obj.Height^2).*(obj.Xpos - p(:,1)))./obj.Width;
        end
                
        function [Grad] = dF(obj,p)
            %dF Summary of this method goes here
            %  This returnd the first order partial derivitves of the
            %  function for a given point
            x = (p(:,1)-obj.Xpos)./obj.Width;
            y = (p(:,2)-obj.Ypos)./obj.Height;
            dx = 1./obj.Width;
            dy = 1./obj.Height;
            a = obj.a;
            dFdx(:,1) = dx*(8*a*x^2 + 4*a*(x^2 + y^2) + 4*x*(x^2 + y^2));
            dFdy(:,1) = dy*(4*y*(x^2 + y^2) - 8*a^2*y + 8*a*x*y);
         
            Grad = [dFdx dFdy];
        end
        
        function [SecondGrad] = ddF(obj,p)
            %ddF Second order partial derivitives (risidual derivitives)
            %  used for La Grange and CB2 Ellim approx
            x = (p(:,1)-obj.Xpos)./obj.Width;
            y = (p(:,2)-obj.Ypos)./obj.Height;
            a = obj.a;
            dx = 1./obj.Width;
            dy = 1./obj.Height;
            ddFdxdx = dx.^2*(12*x^2 + 24*a*x + 4*y^2);
            ddFdxdy = dx*dy*(8*a*y + 8*x*y);
            ddFdydx = dx*dy*(8*a*y + 8*x*y);
            ddFdydy = dy.^2*(-8*a^2 + 8*a*x + 4*x^2 + 12*y^2);
            SecondGrad = [ddFdxdx ddFdxdy;
                          ddFdydx ddFdydy];
        end
                
        function xy = plot(obj)
            %plot Gives boudary plot points
            % This returns signed distance function for a given point
            
            phi = [0:0.001:2*pi]';
            
            x = 2*obj.a.*(1-cos(phi)).*cos(phi).*obj.Width+obj.Xpos;
            y = 2*obj.a.*(1-cos(phi)).*sin(phi).*obj.Height+obj.Ypos;
            
            xy =[x, y];
        end
        
    end
    

end

