classdef f_Ellipse
    %FUNCLASS Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
%         Params = [1 4]';
        Params = [1 4 0.1 0.1]';
        Height;
        Width;
        Xpos;
        Ypos
    end
    
    methods %Get set properties
        
        function obj = set.Height(obj,val)
            obj.Params(1) = val;
        end
        
        function x = get.Height(obj)
            x = obj.Params(1);
        end
        
        function obj = set.Width(obj,val)
            obj.Params(2) = val;
        end
        
        function x = get.Width(obj)
            x = obj.Params(2);
        end        
        
        function obj = set.Xpos(obj,val)
            obj.Params(3) = val;
        end
        
        function x = get.Xpos(obj)
            x = obj.Params(3);
        end
        
        function obj = set.Ypos(obj,val)
            obj.Params(4) = val;
        end
        
        function x = get.Ypos(obj)
            x = obj.Params(4);
        end
    end
    
    
    
    methods (Access = public)
        
        function pfixout = pfix(obj)
            pfixout =[
%                 0 obj.Height
                obj.Width+obj.Xpos obj.Ypos
%                 0 -obj.Height
                -obj.Width+obj.Xpos obj.Ypos
%                 obj.Params(3,1)  obj.Params(4,1)
                ];
        end
        
        function [Func] = F(obj,p)
            %Func This returns the distance function
            % This returns signed distance function for a given point
            x = p(:,1)-obj.Xpos;
            y = p(:,2)-obj.Ypos;
            Func = (x./obj.Width).^2 + (y./obj.Height).^2 - 1;
        end
        
        function [Grad] = dF(obj,p)
            %dF Summary of this method goes here
            %  This returnd the first order partial derivitves of the
            %  function for a given point
            x = p(:,1)-obj.Xpos;
            y = p(:,2)-obj.Ypos;
            dRdu1(:,1) = (2*(x))./(obj.Width^2);
            dRdu2(:,1) = (2*(y))./(obj.Height^2);
            Grad = [dRdu1 dRdu2];
        end
        
        function [SecondGrad] = ddF(obj,p)
            %ddF Second order partial derivitives (risidual derivitives)
            %  used for La Grange and CB2 Ellim approx
            
            ddRdu1du1 = 2/(obj.Width^2);
            ddRdu1du2 = 0;
            ddRdu2du1 = 0;
            ddRdu2du2 = 2/(obj.Height^2);
            
            SecondGrad = [ddRdu1du1 ddRdu1du2;
                          ddRdu2du1 ddRdu2du2];
        end
        
        % Optional
        function xy = plot(obj)
            %plot Gives boudary plot points
            % This returns signed distance function for a given point
            
            x(:,1) = linspace(-obj.Width,obj.Width,1000);
            y1 = (-(x./obj.Width).^2 + 1).^0.5.*obj.Height;
            y2 = -(-(x./obj.Width).^2 + 1).^0.5*obj.Height;
            xy =[x+obj.Xpos, y1+obj.Ypos;
                flip(x)+obj.Xpos, flip(y2)+obj.Ypos];
        end
        
        function pboundsout = pbounds(obj)
            pboundsout =[-obj.Width+obj.Xpos -obj.Height+obj.Ypos 
                          obj.Width+obj.Xpos obj.Height+obj.Ypos];
        end
        
    end
    
   
end

