classdef f_Squircle
    %FUNCLASS Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        Params = [1 4 0.5 1 ]';
%         Params = [1 4 -0.5 -0.5]';
        Height;
        Width;
        Xpos;
        Ypos;
    end
    
    methods %Get set properties
        
        function obj = set.Height(obj,val)
            obj.Params(1) = val;
        end
        
        function x = get.Height(obj)
            x = obj.Params(1);
        end
        
        function obj = set.Width(obj,val)
            obj.Params(2) = val;
        end
        
        function x = get.Width(obj)
            x = obj.Params(2);
        end 
        
        function obj = set.Xpos(obj,val)
            obj.Params(3) = val;
        end
        
        function x = get.Xpos(obj)
            x = obj.Params(3);
        end
        
        function obj = set.Ypos(obj,val)
            obj.Params(4) = val;
        end
        
        function x = get.Ypos(obj)
            x = obj.Params(4);
        end
    end
    
    methods (Access = public)
        
        function pfixout = pfix(obj)
            pfixout =[
%                 0 obj.Height
                obj.Width+obj.Xpos  obj.Ypos
%                 0 -obj.Height
                -obj.Width+obj.Xpos obj.Ypos
%                 obj.Params(3,1)  obj.Params(4,1)
                ];

        end
        
        function pboundsout = pbounds(obj)
            pboundsout =[-obj.Width+obj.Xpos -obj.Height+obj.Ypos 
                          obj.Width+obj.Xpos obj.Height+obj.Ypos];
        end
        
        function [Func] = F(obj,p)
            %Func This returns the distance function
            % This returns signed distance function for a given point
            Func = ((p(:,1)-obj.Xpos)./obj.Width).^4 + ((p(:,2)-obj.Ypos)./obj.Height).^4 - 1;
        end
                
        function [Grad] = dF(obj,p)
            %dF Summary of this method goes here
            %  This returnd the first order partial derivitves of the
            %  function for a given point
            dRdu1(:,1) = 4.*(((p(:,1)-obj.Xpos).^3)./obj.Width.^4);
            dRdu2(:,1) = 4.*(((p(:,2)-obj.Ypos).^3)./obj.Height.^4);
            Grad = [dRdu1 dRdu2];
        end
        
        function [SecondGrad] = ddF(obj,p)
            %ddF Second order partial derivitives (risidual derivitives)
            %  used for La Grange and CB2 Ellim approx
            
            ddRdu1du1 = 12.*(((p(:,1)-obj.Xpos).^2)./obj.Width.^4);
            ddRdu1du2 = 0;
            ddRdu2du1 = 0;
            ddRdu2du2 = 12.*(((p(:,2)-obj.Ypos).^2)./obj.Height.^4);
            
            SecondGrad = [ddRdu1du1 ddRdu1du2;
                          ddRdu2du1 ddRdu2du2];
        end
                
        function xy = plot(obj)
            %plot Gives boudary plot points
            % This returns signed distance function for a given point
            
            x(:,1) = linspace(-obj.Width,obj.Width,2000)+obj.Xpos;
            y1 = (-((x -obj.Xpos)./obj.Width).^4 + 1).^0.25.*obj.Height +obj.Ypos;
            y2 = -(-((x -obj.Xpos)./obj.Width).^4 + 1).^0.25*obj.Height +obj.Ypos;
            xy =[x, y1;
                flip(x), flip(y2)];
        end
        
    end
    

end

