classdef heart2
    %FUNCLASS Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        Params = [2 2 0 0]';
%         Params = [1 4 -0.5 -0.5]';
        Height;
        Width;
        Xpos;
        Ypos;
        a;
    end
    
    methods %Get set properties
        
        function x = get.Width(obj)
            x = obj.Params(1);
        end 
        
        function x = get.Height(obj)
            x = obj.Params(2);
        end 
        
        function x = get.Xpos(obj)
            x = obj.Params(3);
        end
        
        function x = get.Ypos(obj)
            x = obj.Params(4);
        end       
        
    end
    
    methods (Access = public)
        
        function pfixout = pfix(obj)
            pfixout =[obj.Xpos  obj.Ypos+obj.Height
                      obj.Xpos  obj.Ypos-obj.Height
                      obj.Xpos+obj.Width  obj.Ypos
                      obj.Xpos-obj.Width  obj.Ypos];
        end
        
        function pboundsout = pbounds(obj)
            pboundsout =[-2*obj.Width+obj.Xpos -2*obj.Height+obj.Ypos 
                          2*obj.Width+obj.Xpos 2*obj.Height+obj.Ypos];
        end
        
        function [Func] = F(obj,p)
            %Func This returns the distance function
            % This returns signed distance function for a given point
            
            x = (p(:,1)-obj.Xpos)./obj.Width;
            y = (p(:,2)-obj.Ypos)./obj.Height;
            Func = ((x.^2+y.^2-1).^3-x.^2.*y.^3);            
        end
                
        function [Grad] = dF(obj,p)
            %dF Summary of this method goes here
            %  This returnd the first order partial derivitves of the
            %  function for a given point
                       
            px = p(:,1);
            py = p(:,2);
            W = obj.Width;
            H = obj.Height;
            Xp = obj.Xpos;
            Yp = obj.Ypos;            
            
            dRdu1 =- (3*(2*Xp - 2*px)*((Yp - py)^2/H^2 + (Xp - px)^2/W^2 - 1)^2)/W^2 - ((Yp - py)^3*(2*Xp - 2*px))/(H^3*W^2);
            dRdu2 =- (3*(2*Yp - 2*py)*((Yp - py)^2/H^2 + (Xp - px)^2/W^2 - 1)^2)/H^2 - (3*(Xp - px)^2*(Yp - py)^2)/(H^3*W^2);
            
 
            
            Grad = [dRdu1 dRdu2];
        end
        
        function [SecondGrad] = ddF(obj,p)
            %ddF Second order partial derivitives (risidual derivitives)
            %  used for La Grange and CB2 Ellim approx
            px = p(:,1);
            py = p(:,2);
            W = obj.Width;
            H = obj.Height;
            Xp = obj.Xpos;
            Yp = obj.Ypos;
            
            ddRdu1du1 =(6*((Yp - py)^2/H^2 + (Xp - px)^2/W^2 - 1)^2)/W^2 + (24*(Xp - px)^2*((Yp - py)^2/H^2 + (Xp - px)^2/W^2 - 1))/W^4 + (2*(Yp - py)^3)/(H^3*W^2);
            ddRdu1du2 =(3*(Yp - py)^2*(2*Xp - 2*px))/(H^3*W^2) + (6*(2*Xp - 2*px)*(2*Yp - 2*py)*((Yp - py)^2/H^2 + (Xp - px)^2/W^2 - 1))/(H^2*W^2);
            ddRdu2du1 =(3*(Yp - py)^2*(2*Xp - 2*px))/(H^3*W^2) + (6*(2*Xp - 2*px)*(2*Yp - 2*py)*((Yp - py)^2/H^2 + (Xp - px)^2/W^2 - 1))/(H^2*W^2);
            ddRdu2du2 =(6*((Yp - py)^2/H^2 + (Xp - px)^2/W^2 - 1)^2)/H^2 + (24*(Yp - py)^2*((Yp - py)^2/H^2 + (Xp - px)^2/W^2 - 1))/H^4 + (3*(Xp - px)^2*(2*Yp - 2*py))/(H^3*W^2);

             
            SecondGrad = [ddRdu1du1 ddRdu1du2;
                          ddRdu2du1 ddRdu2du2];
        end
                
        function xy = plot(obj)
            %plot Gives boudary plot points
            % This returns signed distance function for a given point
            bounds = obj.pbounds;
            CurFig = gcf;
            [x,y] = meshgrid(bounds(1,1):.01:bounds(2,1),bounds(1,2):.01:bounds(2,2));
            zz = obj.F([reshape(x,[],1),reshape(y,[],1)]);
            z = reshape(zz,size(x,1),size(x,2));
            aa =figure(100)
            [C,h] = contour(x,y,z,[0 0]);
            
            Lvls = h.LevelList;
            k1 = 1;
            idxc = find(C(1,:) == Lvls(k1));
            Llen = C(2,idxc);
            xy = C(:,idxc(1)+1 : idxc(1)+1+Llen(1)-1)';
            close(aa)
            figure(CurFig)
        end
        
    end
    

end

