function [nnodes,ndcoor,nodes,coor,nelem,plane,elnodes,elas,pois,t,ndispl,...
displ,ncload,cload,nloadinc] = read_input_file(filename,ElType)

if (ElType == 'q4')|(ElType=='5B')
    NodesPerEl = 4;
elseif ElType == 'q8'
    NodesPerEl = 8;
end

% Open input file
fid = fopen([filename,'.inp'],'r');

tic;
% Read number of nodes
dummy = fgetl(fid);
nnodes = fscanf(fid,'%d \n',1);

%Read nodal coordinates
dummy = fgetl(fid);
%dummy = fgetl(fid);
ndcoor = fscanf(fid,'%f \n',[3,nnodes])';

% Store node numbers in nodes
nodes = round(ndcoor(:,1));

% Store coordinates in coord
coor = ndcoor(:,2:3);

% Read number of elements
dummy = fgetl(fid);
nelem = fscanf(fid,'%5d \n',1);

% Read if elements are plane stress or plain strain
dummy = fgetl(fid);
plane = fscanf(fid,'%1d \n',1);

% Read element number and element connectivity 
dummy = fgetl(fid);
elnodes = fscanf(fid,'%5d \n',[1+NodesPerEl,nelem])';

% Read material constants
dummy = fgetl(fid);
elas = fscanf(fid,'%f',1);
pois = fscanf(fid,'%f',1);

% Read element thickness
t = fscanf(fid,'%f \n',1);

% Read number of prescribed displacements
dummy = fgetl(fid);
ndispl = fscanf(fid,'%5d \n',1);

% Read prescribed displacements;
dummy = fgetl(fid);
displ = fscanf(fid,'%f \n',[3,ndispl])';
displ = sortrows(displ);

% Read number of nodal loads
dummy = fgetl(fid);
ncload = fscanf(fid,'%5d \n',1);

% Read nodal loads
dummy = fgetl(fid);
cload = fscanf(fid,'%f \n',[3,ncload])';

% Read number of load increments
dummy = fgetl(fid);
nloadinc = fscanf(fid,'%d \n',1);

fclose(fid);
finish = toc;
disp(['Done reading input file             : ',num2str(finish),' seconds'])
